/*
 * Copyright (C) 2007 NetXen Inc.
 * 
 * All rights reserved.
 * 
 * The code contained in this file has been developed by NetXen Inc.
 * 
 * By downloading, compiling or using the code in any form, you agree to be bound
 * by the following terms:
 * 
 * 1) You may compile the unmodified source code file and reproduce and install
 * the resulting binary code file solely for your internal use with NetXen Inc.
 * hardware and systems you have purchased.
 * 
 * 2) Except as expressly permitted herein or in a separately signed agreement,
 * any other use, reproduction, distribution, modification, display, creation
 * of derivative works or circulation of the code is strictly prohibited.  You
 * may not transfer the code or assign your rights or obligations hereunder
 * without the prior written consent of NetXen Inc.
 * 
 * 3) This file contains confidential, proprietary and trade secret information
 * of NetXen Inc. and may not be disclosed to any third party or used for any
 * other purpose, except as expressly permitted herein.
 * 
 * 4) THIS SOFTWARE IS PROVIDED “AS IS” AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETXEN INC.
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.  THE APPLICATION OF THE UNITED NATIONS CONVENTION
 * ON CONTRACTS FOR THE INTERNATIONAL SALE OF GOODS IS HEREBY DISCLAIMED.
 * 
 * If you do not agree to the foregoing terms, you may not download, use or
 * compile this code in any form and must promptly delete or destroy all copiesi
 * of the code you have downloaded, compiled or reproduced.
 * 
 * Contact Information:
 * licensing@netxen.com
 * NetXen Inc.
 * 3965 Freedom Circle, Fourth Floor
 * Santa Clara, CA 95054
 * 
 */
/*
 * Copyright and CVS version tags.
 */
#ifndef	_NX_INTERCEPT_H
#define	_NX_INTERCEPT_H

#include <linux/wait.h>
#include <linux/inetdevice.h>
#include <linux/if.h>
#include <linux/in.h>
#include <linux/net.h>


typedef int (*nx_ioctl_t)(struct socket *, unsigned int,
			  unsigned long);

typedef struct {
	struct proto_ops	lsa_stream_ops;
	nx_ioctl_t		lsa_dgram_ioctl;
} nx_intercept_registry_t;

typedef struct {
	struct proto_ops	host_stream_ops;
	nx_ioctl_t		host_dgram_ioctl;
} nx_intercept_info_t;

/*
 * Intercept module functions.
 */
int nx_lsa_register_ops(nx_intercept_registry_t *registry,
			nx_intercept_info_t *ret_info);
void nx_lsa_unregister_ops(void);
struct sock *get_offload_listener_sk(struct iphdr *iph);
struct net_device *nx_find_dev_for_ip(u32 addr);

#define	UNM_SOCK_IS_SOCK_OFFLOADED(SOCK)                        \
	((SOCK)->sk && (SOCK)->sk->SK_FAMILY == AF_INET &&      \
	 (SOCK)->sk->SK_PROTINFO)

#endif	/* _NX_INTERCEPT_H */
